#include "bits/stdc++.h"

using namespace std;
#define int long long


signed main() {
#ifdef LOCAL
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w",stdout);
#else
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
#endif
	int n;
	cin >> n;

	vector<int> prev(n + 1);
	vector<int> now(n + 1);
	
	vector<bool> used(n + 1);
	vector<array<int, 3>> iand;
	vector<array<int, 2>> ne;
	int k, t;
	
	for (int i = 0; i < n; ++i) {
		int type;
		cin >> type;
		int x, y;
		cin >> x >> y;
		
		if (type == 0) {
			prev[x] = y;
		}
		if (type == 1) {
			ne.push_back({x, y});
			used[y] = true;
		}
		if (type == 2) {
			int z;
			cin >> z;
			
			iand.push_back({x, y, z});
			used[z] = true;
		}
		
		if (type == 3) {
			k = x, t = y;
		}
	}
	
	while (t--) {
		for (int i = 0; i <= n; ++i) if (!used[i]) now[i] = prev[i];
		for (auto temp: ne) {
			int x = temp[0], y = temp[1];
			now[y] |= (!prev[x]);
		}
		for (auto temp: iand) {
			int x = temp[0], y = temp[1], z = temp[2];
			now[z] |= (prev[x] & prev[y]);
		}
		cout << now[k] << '\n';
		prev = now;
		now.assign(n + 1, 0);
	}
}