﻿#include <iostream>
#include <stdio.h>
#include <algorithm>
#include <vector>
#include <string>
#include <set>
#include <map>

#define int long long
#define ld long double
#define INF 1e18

using namespace std;

signed main() {
	string alf; cin >> alf;
	int a, b; cin >> a >> b;
	string hvost; cin >> hvost;
	map<char, char> mp;
	for (auto c : alf) {
		mp[c] = '0' + mp.size();
	}
	string coded;
	for (auto c : hvost) {
		coded += mp[c];
	}
	reverse(coded.begin(), coded.end());
	int base = alf.size();
	int ans = 0;
	for (int i = a; i <= b; i++) {
		int ii = i;
		string curr;
		while (ii) {
			curr.push_back(ii % base + '0');
			ii /= base;
		}
		if (curr.size() < coded.size()) {
			continue;
		}
		bool ok = true;
		for (int j = 0; j < coded.size(); j++) {
			if (coded[j] != curr[j]) {
				ok = false;
				break;
			}
		}
		ans += ok;
	}
	cout << ans;
}