﻿#include <iostream>
#include <stdio.h>
#include <algorithm>
#include <vector>
#include <string>
#include <set>
#include <map>

#define int long long
#define ld long double
#define INF 1e18

using namespace std;

struct no {
	int enter, exit;
};

struct an {
	int enter1, enter2, exit;
};

signed main() {
	int n; cin >> n;
	map<int, int> points;
	vector<no> nos;
	vector<an> ands;
	int watch = 1, t = 1;
	for (int i = 0; i < n; i++) {
		int type; cin >> type;
		if (type == 0) {
			int number, signal; cin >> number >> signal;
			points[number] = signal;
		}
		else if (type == 1) {
			no nn; cin >> nn.enter >> nn.exit;
			nos.push_back(nn);
		}
		else if (type == 2) {
			an ad; cin >> ad.enter1 >> ad.enter2 >> ad.exit;
			ands.push_back(ad);
		}
		else {
			cin >> watch >> t;
		}
	}
	while (t--) {
		map<int, vector<int>> points_signals;
		for (auto no : nos) {
			points_signals[no.exit].push_back(1 - points[no.enter]);
		}
		for (auto ad : ands) {
			int output_signal = (points[ad.enter1] && points[ad.enter2]);
			points_signals[ad.exit].push_back(output_signal);
		}
		for (auto p : points_signals) {
			int num = p.first;
			vector<int> sigs = p.second;
			int sig = 0;
			for (int i = 0; i < sigs.size(); i++) {
				if (sigs[i] == 1) {
					sig = 1;
					break;
				}
			}
			points[num] = sig;
		}
		cout << points[watch] << '\n';
	}
}