﻿#include <iostream>
#include <vector>
#include <set>
#include <algorithm>
#include <cmath>
#include <string>
#include <queue>
#include <map>

using namespace std;

using ll = long long;
using vll = vector<ll>;
using str = string;

ll gcd(ll a, ll b) {
    if (b > a) swap(a, b);
    if (b == 0) return a;
    return gcd(b, a % b);
}


map<ll, vll> g;

void bfs(ll v,ll n) {
    queue<ll> stack;
    vll used(n + 1);
    stack.push(v);
    used[v] = 1;
    while (!stack.empty()) {
        ll ver = stack.front();
        cout << ver << endl;
        stack.pop();
        for (auto i : g[ver]) {
            if (used[i] == 0) {
                stack.push(i);
                used[i] = 1;
            }
        }
    }
}

void fast() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
}

int main()
{
    fast();
    ll n, m;
    cin >> m >> n;
    ll cnt = 0,ans1 = 0,ans2 = 0;
    vector<pair<ll,ll>> data;
    for (int i = 0; i < n; i++) {
        ll u, v;
        cin >> u >> v;
        data.push_back({ u, v });
    }
    sort(data.begin(), data.end());
    vll ang(2,-1);
    for (int i = 0; i < n; i++) {
        ll date, t;
        date = data[i].first;
        t = data[i].second;
        if (t == 1) {
            if (cnt == 2) { ans1 += 1; }
            else {
                cnt++;
                if (ang[0] == -1) ang[0] = date + m;
                else if (ang[1] == -1) ang[1] = date + m;
            }
        }
        if (t == -1) {
            if (ang[0] <= date && ang[1] <= date && ang[0] != -1 && ang[1] != -1) {
                if (ang[0] < ang[1]) ang[0] = -1;
                else ang[1] = -1;
                cnt--;
            }
            else if (ang[0] <= date && ang[0] != -1) { ang[0] = -1; cnt--; }
            else if (ang[1] <= date && ang[1] != -1) {
                ang[1] = -1; cnt--;
            }
            else ans2++;
        }
    }
    cout << ans1 << endl;
    cout << ans2 << endl;

}

