﻿#include <iostream>
#include <vector>
#include <set>
#include <algorithm>
#include <cmath>
#include <string>
#include <queue>
#include <map>

using namespace std;

using ll = long long;
using vll = vector<ll>;
using str = string;

ll gcd(ll a, ll b) {
    if (b > a) swap(a, b);
    if (b == 0) return a;
    return gcd(b, a % b);
}


map<ll, vll> g;

void bfs(ll v,ll n) {
    queue<ll> stack;
    vll used(n + 1);
    stack.push(v);
    used[v] = 1;
    while (!stack.empty()) {
        ll ver = stack.front();
        cout << ver << endl;
        stack.pop();
        for (auto i : g[ver]) {
            if (used[i] == 0) {
                stack.push(i);
                used[i] = 1;
            }
        }
    }
}

void fast() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
}

int main()
{
    fast();
    ll n,ans = 0, m,sr = 0;
    cin >> n;
    cin >> m;
    vll a,p;
    for (int i = 0; i < n; i++){
        ll k;
        cin >> k;
        sr += k;
        a.push_back(k);
    }
    sr = (sr + n - 1) / n;
    for (auto i : a) {
        if (i > m && i < sr) p.push_back(i);
    }
    if (p.size() == 0) cout << 0 << endl;
    else {
        map<ll, ll> cnt;
        for (auto i : p) cnt[i]++;
        ll ma = 0, num = 0;
        for (auto para : cnt) {
            if (para.second > ma) {
                ma = para.second;
                num = para.first;
            }
        }
        cout << num << endl;
    }
}

